/**
* DO NOT EDIT THIS FILE.
* See the following change record for more information,
* https://www.drupal.org/node/2815083
* @preserve
**/

(function ($, Drupal, drupalSettings) {
  drupalSettings.dialog = {
    autoOpen: true,
    dialogClass: '',

    buttonClass: 'button',
    buttonPrimaryClass: 'button--primary',
    close: function close(event) {
      Drupal.bs4_modal(event.target).close();
      Drupal.detachBehaviors(event.target, null, 'unload');
    }
  };

  Drupal.bs4_modal = function (element, options) {
    var undef = void 0;
    var $element = $(element);
    var dialog = {
      open: false,
      returnValue: undef
    };

    function openDialog(settings) {
      settings = $.extend({}, drupalSettings.dialog, options, settings);

      $(window).trigger('dialog:beforecreate', [dialog, $element, settings]);

      if (settings.modalDialogClasses !== undefined) {
        $('.modal-dialog', $element).removeAttr('class').addClass('modal-dialog').addClass(settings.modalDialogClasses);
      }

      if (settings.modalDialogShowHeader !== undefined && (settings.modalDialogShowHeader === true || settings.modalDialogShowHeader == 'true')) {
        var modalHeader = $('<div class="modal-header"><h5 class="modal-title">' + settings.title + '</h5><button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button></div>').prependTo($('.modal-dialog .modal-content', $element));
      } else {
        var modalHeader = $('<div class="modal-header"><button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button></div>').prependTo($('.modal-dialog .modal-content', $element));
      }

      $element.modal(settings);
      $element.modal('show');
      // dialog.open = true;
      $(window).trigger('dialog:aftercreate', [dialog, $element, settings]);
    }

    function closeDialog(value) {
      $(window).trigger('dialog:beforeclose', [dialog, $element]);
      $element.modal('hide');
      dialog.returnValue = value;
      dialog.open = false;
      $(window).trigger('dialog:afterclose', [dialog, $element]);
    }

    dialog.show = function () {
      openDialog({ modal: false });
    };
    dialog.showModal = function () {
      openDialog({ modal: true });
    };
    dialog.close = closeDialog;
    
    $element.on('hide.bs.modal', function (e) {
       $(window).trigger('dialog:beforeclose', [dialog, $element]) ;
    });
    
    $element.on('hide.bs.modal', function (e) {
       $(window).trigger('dialog:afterclose', [dialog, $element]) ;
    });
    
    return dialog;
  };
})(jQuery, Drupal, drupalSettings);
